/*--------------------------------------------------------------------------+
$Id$
|                                                                          |
| Copyright 2011 ForTISS GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.tooling.kernel.services;

import org.eclipse.emf.ecore.EObject;
import org.fortiss.tooling.kernel.interfaces.ICompositionContext;
import org.fortiss.tooling.kernel.internal.CompositorService;

/**
 * The compositor service provides registration and access to model element
 * compositors.
 * 
 * @author hoelzl
 * @author $Author$
 * @version $Rev$
 * @levd.rating RED Rev:
 */
public interface ICompositorService {

	/** Returns the singleton instance of the service. */
	public static final ICompositorService INSTANCE = new CompositorService();

	/**
	 * Determines if there is a compositor that allows the composition of the
	 * container and the prototype {@link EObject}.
	 */
	boolean canCompose(EObject container, EObject element,
			ICompositionContext context);

	/**
	 * Composes the container and the element. Since this operation may be
	 * canceled by the user, it returns a boolean value.
	 */
	boolean compose(EObject container, EObject element,
			ICompositionContext context);
}
